<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>library_dir_dir/include/rdc_next_stmt_.incl.pl1</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="pl1">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.Macro { color: #00afaf; }
.pliRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.Repeat { color: #af87d7; font-weight: bold; }
.Conditional { color: #af87d7; font-weight: bold; }
.Number { color: #ff5faf; }
.Boolean { color: #d7af00; font-weight: bold; }
.Operator { color: #5fafd7; }
.Keyword { color: #00afaf; }
.Comment { color: #808080; }
.Normal { color: #d0d0d0; background-color: #000000; padding-bottom: 1px; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>          <span class="Comment">/* START OF:        rdc_next_stmt_.incl.pl1         *  *  *  *  *  *  */</span>
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
<span id="L4" class="LineNr"> 4 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L5" class="LineNr"> 5 </span>          <span class="Comment">/* N^H__^Ha_^Hm_^He:  rdc_next_stmt_.incl.pl1                                   */</span>
<span id="L6" class="LineNr"> 6 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L7" class="LineNr"> 7 </span>          <span class="Comment">/*      This include segment is used by compilers generated by the    */</span>
<span id="L8" class="LineNr"> 8 </span>          <span class="Comment">/* reduction_compiler.  It includes a procedure which shifts the      */</span>
<span id="L9" class="LineNr"> 9 </span>          <span class="Comment">/* compilation process to the next source statement.                  */</span>
<span id="L10" class="LineNr">10 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L11" class="LineNr">11 </span>          <span class="Comment">/* S^H__^Ht_^Ha_^Ht_^Hu_^Hs                                                               */</span>
<span id="L12" class="LineNr">12 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L13" class="LineNr">13 </span>          <span class="Comment">/* 0) Created:  April, 1974 by G. C. Dixon                            */</span>
<span id="L14" class="LineNr">14 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L15" class="LineNr">15 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
<span id="L16" class="LineNr">16 </span>
<span id="L17" class="LineNr">17 </span>
<span id="L18" class="LineNr">18 </span><span class="Normal">NEXT_STMT</span><span class="Operator">:</span>          <span class="Keyword">procedure</span><span class="Normal">;</span>                              <span class="Comment">/* invoked to begin parsing the next statement of */</span>
<span id="L19" class="LineNr">19 </span>                                                            <span class="Comment">/* the input tokens.                              */</span>
<span id="L20" class="LineNr">20 </span>
<span id="L21" class="LineNr">21 </span>     <span class="Keyword">dcl</span>  <span class="Boolean">null</span>                          <span class="Macro">builtin</span><span class="Normal">,</span>
<span id="L22" class="LineNr">22 </span>          <span class="Normal">Ssearching</span>                    <span class="Macro">bit</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">1</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">aligned</span><span class="Normal">;</span>
<span id="L23" class="LineNr">23 </span>
<span id="L24" class="LineNr">24 </span>          <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">Pthis_token</span><span class="Normal">;</span>                             <span class="Comment">/* make sure these pointers are the same.         */</span>
<span id="L25" class="LineNr">25 </span>          <span class="Normal">Pstmt</span> <span class="Operator">=</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pstmt</span><span class="Normal">;</span>                              <span class="Comment">/* address &quot;current&quot; statement's descriptor.      */</span>
<span id="L26" class="LineNr">26 </span>          <span class="Normal">Ssearching</span> <span class="Operator">=</span> <span class="Operator">&quot;</span><span class="Number">1</span><span class="Operator">&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>                                <span class="Comment">/* start scanning forward for next statement.     */</span>
<span id="L27" class="LineNr">27 </span>          <span class="Keyword">do</span> <span class="Repeat">while</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Ssearching</span> <span class="Operator">&amp;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">^=</span> <span class="Boolean">null</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L28" class="LineNr">28 </span>               <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span><span class="Normal">;</span>
<span id="L29" class="LineNr">29 </span>               <span class="Conditional">if</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pstmt</span> <span class="Operator">=</span> <span class="Normal">Pstmt</span> <span class="Keyword">then</span><span class="Normal">;</span>
<span id="L30" class="LineNr">30 </span>               <span class="Conditional">else</span> <span class="Normal">Ssearching</span> <span class="Operator">=</span> <span class="Operator">&quot;</span><span class="Number">0</span><span class="Operator">&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>
<span id="L31" class="LineNr">31 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L32" class="LineNr">32 </span>          <span class="Conditional">if</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pstmt</span> <span class="Operator">=</span> <span class="Normal">Pstmt</span> <span class="Keyword">then</span>                       <span class="Comment">/* if there is no next statement, and             */</span>
<span id="L33" class="LineNr">33 </span>               <span class="Conditional">if</span> <span class="Normal">SPDL</span> <span class="Keyword">then</span>                                 <span class="Comment">/*   in PUSH DOWN LANGUAGE mode, can't run off    */</span>
<span id="L34" class="LineNr">34 </span>                    <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">Ptoken</span><span class="Normal">;</span>                        <span class="Comment">/*   end of input list.                           */</span>
<span id="L35" class="LineNr">35 </span>               <span class="Conditional">else</span> <span class="Normal">Ptoken</span><span class="Normal">,</span> <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>             <span class="Comment">/*   otherwise, input list exhausted.             */</span>
<span id="L36" class="LineNr">36 </span>          <span class="Conditional">else</span> <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Normal">Ptoken</span><span class="Normal">;</span>                        <span class="Comment">/* normally, next statement exists and Ptoken     */</span>
<span id="L37" class="LineNr">37 </span>                                                            <span class="Comment">/*   points to its 1st _^Hn_^Ho_^Hn-^H__^Hd_^He_^Hl_^He_^Ht_^He_^Hd token.      */</span>
<span id="L38" class="LineNr">38 </span>
<span id="L39" class="LineNr">39 </span>          <span class="Keyword">end</span> <span class="Normal">NEXT_STMT</span><span class="Normal">;</span>
<span id="L40" class="LineNr">40 </span>
<span id="L41" class="LineNr">41 </span>          <span class="Comment">/* END OF:          rdc_next_stmt_.incl.pl1         *  *  *  *  *  *  */</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
